#include <iostream>
#include <stdlib.h>
#include <string.h>
using namespace std;

const int MAXL = 100;
const int MAXN = 50;

enum Categoria {SPORT, NEWS, DIVERTIMENTO, STUDIO};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Bookmark {
  char url[MAXL];
  Categoria cat;
  int visite;
  Data data;
};

struct BMSistGest {
  Bookmark bm[MAXN];
  int numBM;
};

int piuVisitati(const BMSistGest* pa, Bookmark v[]); 
bool salva(const BMSistGest* pa, const char filename[]);
bool visita(BMSistGest* pa, const char nomesito[]);
int eliminaCat(BMSistGest* pa, Categoria c);
int quanti(const BMSistGest* pa, Data da, Data a);

void menu(){
  cout << "\n\n------------------------" << endl;
  cout << "1) mostra bookmark" << endl;
  cout << "2) visita" << endl;
  cout << "3) salva" << endl;
  cout << "4) piu visitati" << endl;
  cout << "5) elimina categoria" << endl;
  cout << "6) quanti" << endl;
  cout << "7) esci" << endl;
  cout << "Scelta? ";
}



void stampaBookmark(Bookmark b) {
  cout << b.url << " ";
  switch(b.cat) {
    case SPORT:
      cout << "sport";
      break;
    case NEWS:
      cout << "news";
      break;
    case DIVERTIMENTO:
      cout << "divertimento";
      break;
    case STUDIO:
      cout << "studio";
  }
  cout << " " << b.visite << " " << b.data.giorno << "/" << b.data.mese << "/" << b.data.anno << endl;
}

void mostra(const BMSistGest* pa) {
  cout << "Bookmark presenti:" << endl;
  for(int i=0; i<pa->numBM; i++)
    stampaBookmark(pa->bm[i]);
}

void provaElimina(BMSistGest* pa){
  Categoria tmp[] = {SPORT, NEWS, DIVERTIMENTO, STUDIO};  
  int i;
  do {
    cout << "Quale categoria vuoi eliminare?" << endl;
    cout << "0) sport" << endl;
    cout << "1) news" << endl;
    cout << "2) divertimento" << endl;
    cout << "3) studio" << endl;
    cin >> i;
  } while(i<0 || i>3);
  int e = eliminaCat(pa, tmp[i]);
  cout << "Ho eliminato " << e << " bookmark" << endl;
}

void inserisci(BMSistGest* pa, const char* u, Categoria c, int g, int m, int a){
  Data d;
  d.giorno = g;
  d.mese = m;
  d.anno = a;
  pa->bm[pa->numBM].data = d;
  strcpy(pa->bm[pa->numBM].url, u);
  pa->bm[pa->numBM].cat = c;
  pa->bm[pa->numBM].visite = 0;
  pa->numBM++;
}

void riempi(BMSistGest* pa) {
  inserisci(pa, "www.repubblica.it", NEWS, 12, 2, 2007);
  inserisci(pa, "www.ing.unipi.it", STUDIO, 18, 5, 2006);
  inserisci(pa, "www.cnn.com", NEWS, 6, 9, 2008);
  inserisci(pa, "www.gazzetta.it", SPORT, 3, 10, 2008);
  inserisci(pa, "www.wikipedia.it", STUDIO, 30, 1, 2007);
}

Data leggiData(){
  Data d;
  cout << "giorno? ";
  cin >> d.giorno;
  cout << "mese? ";
  cin >> d.mese;
  cout << "anno? ";
  cin >> d.anno;
  return d;
}

int main(){
  int k, q;
  Data da, a;
  Bookmark tmp[MAXN];
  char nome[MAXL];
  BMSistGest bma;
  bma.numBM = 0;
  riempi(&bma);
  char c;
  bool res;
  while(true) {
    menu();
    cin >> c;
    switch(c){
      case '1':
        mostra(&bma);
        break;
      case '2':
        cout << "Inserisci il nome del sito: ";
        cin >> nome;
        res = visita(&bma, nome);
        if(res) cout << "Numero visite incrementato" << endl;
        else cout << "Non trovato" << endl;
        break;
      case '3':
        if(salva(&bma, "out.txt")) {
          cout << "Contenuto del file:" << endl;
          system("type out.txt");
        } else cout << "Salvataggio non riuscito" << endl;
        break;
      case '4':
        k = piuVisitati(&bma, tmp);
        for(int i=0; i<k; i++)
          stampaBookmark(tmp[i]);
        break;
      case '5':
        provaElimina(&bma);
        break;   
      case '6':
        cout << "Inserisci la data di inizio" << endl;
        da = leggiData();
        cout << "Inserisci la data di fine" << endl;
        a = leggiData();
        q = quanti(&bma, da, a);
        cout << "In tale periodo sono stati aggiunti " << q << " bookmark" << endl;
        break;
      case '7':
        return 0; 
      default:
        cout << "Scelta inesistente" << endl;
    }
  }
}
