#include <fstream>
#include <string.h>
using namespace std;

const int MAXL = 100;
const int MAXN = 50;

enum Categoria {SPORT, NEWS, DIVERTIMENTO, STUDIO};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Bookmark {
  char url[MAXL];
  Categoria cat;
  int visite;
  Data data;
};

struct BMSistGest {
  Bookmark bm[MAXN];
  int numBM;
};

void ordinaVis(Bookmark vett[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++) 
      if(vett[j].visite > vett[index].visite)
        index = j;
    Bookmark tmp = vett[i];
    vett[i] = vett[index];
    vett[index] = tmp;
  }
}

int piuVisitati(const BMSistGest* pa, Bookmark v[]) {
  Bookmark aux[MAXN];
  int n = pa->numBM;
  for(int i=0; i<n; i++)
    aux[i] = pa->bm[i];
  ordinaVis(aux, n);
  int j;
  for(j=0; j<3 && j<n; j++)
    v[j]=aux[j];
  return j;
}

void formatta(char* a, const char* b, int n) {
  strcpy(a, b);
  int l = strlen(b);
  for(int i=l; i<n-1; i++)
    a[i] = ' ';
  a[n-1] = '\0';
}

bool salva(const BMSistGest* pa, const char filename[]) {
  fstream ff;
  ff.open(filename, ios::out);
  if(!ff) return false;
  const int LEN = 20;
  char buffer[LEN];
  for(int i=0; i<=(int) STUDIO; i++) {
    Categoria c = (Categoria) i;
    for(int j=0; j<pa->numBM; j++)
      if(pa->bm[j].cat == c){
        formatta(buffer, pa->bm[j].url, LEN);
        ff << buffer; 
        switch(pa->bm[j].cat) {
          case SPORT:
            formatta(buffer, "sport", LEN);
            ff << buffer;
            break;
          case NEWS:
            formatta(buffer, "news", LEN);
            ff << buffer;
            break;
          case DIVERTIMENTO:
            formatta(buffer, "divertimento", LEN);
            ff << buffer;
            break;
          case STUDIO:
            formatta(buffer, "studio", LEN);
            ff << buffer;
            break;
        }
        ff << '\t' << pa->bm[j].visite << '\t';
        ff << pa->bm[j].data.giorno << '/' << pa->bm[j].data.mese << '/' << pa->bm[j].data.anno << endl; 
      }
  }
  return true;
}

bool visita(BMSistGest* pa, const char nomesito[]) {
  for(int i=0; i<pa->numBM; i++)
    if(strcmp(pa->bm[i].url, nomesito)==0) {
      pa->bm[i].visite++;
      return true;
    }
  return false;
}

int confronta(Data a, Data b) {
  if(a.anno != b.anno) return a.anno - b.anno;
  if(a.mese != b.mese) return a.mese - b.mese;
  return a.giorno - b.giorno;
}

int quanti(const BMSistGest* pa, Data da, Data a) {
  int conta = 0;
  for(int i=0; i<pa->numBM; i++)
    if(confronta(pa->bm[i].data, da) >= 0 && confronta(pa->bm[i].data, a) <= 0)
      conta++;
  return conta;
}

int eliminaCat(BMSistGest* pa, Categoria c) {
  int conta = 0;
  for(int j=0; j<pa->numBM; j++)
    if(pa->bm[j].cat == c) {
      conta++;
      pa->bm[j] = pa->bm[pa->numBM-1];
      pa->numBM--;
      j--;
    }
  return conta;
}
